<?php
session_start();

// Verificar si el código ha sido verificado
if (!isset($_SESSION['codigo_verificado']) || $_SESSION['codigo_verificado'] !== true) {
  header("Location: index.html");
  exit();
}

// Obtener los datos de la sesión
$nombre = $_SESSION['nombre'];
$correo = $_SESSION['correo'];
$codigo = $_SESSION['codigo'];

// Eliminar los datos de la sesión
unset($_SESSION['codigo_verificado']);
unset($_SESSION['nombre']);
unset($_SESSION['correo']);
unset($_SESSION['codigo']);
?>

<!DOCTYPE html>
<html lang="es">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>TUYA: Take Up Your Authority</title>
  <link rel="stylesheet" href="estilo.css">
</head>
<body>
  <header>
    <div class="banner">
      <img src="logo_TUYA_web.png" alt="TUYA: Take Up Your Authority">
    </div>
  </header>

  <div class="container">
    <h1>Bienvenido(a), <?php echo $nombre; ?>!</h1>
    <p>Tu código de acceso es: <?php echo $codigo; ?></p>
    <p>Se ha enviado un correo electrónico a <?php echo $correo; ?> con los detalles de tu código de acceso.</p>
  </div>

  <footer>
    <p>Todos los derechos reservados &copy; 2023</p>
  </footer>

  <?php
  // Cerrar la sesión
  session_destroy();
  ?>
</body>
</html>
