<?php

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

session_start();

// Conectar a la base de datos
$conexion = mysqli_connect("localhost", "tuya", "Equip@Tuya,22!", "TUYAcod");

// Verificar la conexión
if (!$conexion) {
  die("Error al conectar a la base de datos: " . mysqli_connect_error());
}

// Obtener los datos del formulario
$nombre = $_POST['nombre'];
$correo = $_POST['correo'];

// Validar longitud mínima y máxima del nombre
if (strlen($nombre) < 3 || strlen($nombre) > 50) {
  $error = "El nombre debe tener entre 3 y 50 caracteres.";
  registrarError($error);
  // Manejar el error de validación en el lado del servidor
  // Mostrar el mensaje de error o redirigir a una página de error, según tus necesidades.
  exit();
}

// Validar longitud mínima y máxima del correo electrónico
if (strlen($correo) < 5 || strlen($correo) > 100) {
  $error = "El correo electrónico debe tener entre 5 y 100 caracteres.";
  registrarError($error);
  // Manejar el error de validación en el lado del servidor
  // Mostrar el mensaje de error o redirigir a una página de error, según tus necesidades.
  exit();
}

// Validar formato de correo electrónico válido
if (!filter_var($correo, FILTER_VALIDATE_EMAIL)) {
  $error = "El correo electrónico no tiene un formato válido.";
  registrarError($error);
  // Manejar el error de validación en el lado del servidor
  // Mostrar el mensaje de error o redirigir a una página de error, según tus necesidades.
  exit();
}

// Generar un código hexadecimal de 6 dígitos
$codigo = bin2hex(random_bytes(3));

// Guardar los datos en la base de datos utilizando consultas preparadas
$query = "INSERT INTO usuarios (nombre, email, codigo) VALUES (?, ?, ?)";
$stmt = mysqli_prepare($conexion, $query);
mysqli_stmt_bind_param($stmt, 'sss', $nombre, $correo, $codigo);
$resultado = mysqli_stmt_execute($stmt);
mysqli_stmt_close($stmt);

// Cerrar la conexión a la base de datos
mysqli_close($conexion);

// Ruta del archivo de registro de errores
$logFile = 'error_log.txt';

// Verificar si el archivo de log existe y es modificable
if (!file_exists($logFile) || !is_writable($logFile)) {
  die("Error: No se puede acceder al archivo de registro de errores.");
}

// Función para registrar los errores en el archivo de registro
function registrarError($mensaje) {
  global $logFile;
  $fechaHora = date('Y-m-d H:i:s');
  $registro = "[$fechaHora] $mensaje" . PHP_EOL;
  file_put_contents($logFile, $registro, FILE_APPEND);
}

// Función para enviar el correo electrónico
function enviarCorreo($nombre, $correo, $codigo) {
  require 'vendor/autoload.php'; // Cargar el archivo autoload.php de PHPMailer

  // Configuración del servidor de correo
  $mail = new PHPMailer\PHPMailer\PHPMailer(true);
  $mail->isSMTP();
  $mail->Host = 'smtp.gmail.com';
  $mail->SMTPAuth = true;
  $mail->Username = 'equipo@tuyaapp.es';
  $mail->Password = 'jcydyslaeylllkic';
  $mail->SMTPSecure = PHPMailer\PHPMailer\PHPMailer::ENCRYPTION_STARTTLS;
  $mail->Port = 587;

  // Configuración del remitente y destinatario
  $mail->setFrom('equipo@tuyaapp.es', 'Equipo TUYA');
  $mail->addAddress($correo, $nombre);

  // Contenido del correo
  $mail->Subject = 'Código de acceso formulario';
  $mail->Body = "Tu código de acceso es: $codigo";

  try {
    // Envío del correo
    $mail->send();
    return true; // Envío exitoso
  } catch (Exception $e) {
    $error = "Error al enviar el correo electrónico: " . $mail->ErrorInfo;
    return false; // Error al enviar el correo
  }
}

// Llamar a la función para enviar el correo
if (enviarCorreo($nombre, $correo, $codigo)) {
  // El correo se envió correctamente, establecer la variable de sesión y redirigir a form.php
  $_SESSION['codigo_verificado'] = true;
  $_SESSION['nombre'] = $nombre;
  $_SESSION['correo'] = $correo;
  $_SESSION['codigo'] = $codigo;

  header("Location: ingresar_codigo.php");
  exit();
} else {
  // Error al enviar el correo
  $error = "Error al enviar el correo electrónico. Por favor, inténtalo de nuevo.";
  registrarError($error);
}
